Autodesk Inventor Import Converter - Main Table of Contents

Autodesk Inventorâ Assembly & Parts Import Converter

Quick Jump:

Visual snapshot index of each import converter panel

Overview:

This help file describes the Autodesk Inventor import converter module which allows geometry, hierarchy and materials (assembly data) to be imported from native disk-based Autodesk Inventor files or from a running copy of the Autodesk Inventor 3D solid modeling application using the Autodesk Inventor automation API. No intermediate files are used in the translation.

Note: A 100% equally good and equivalent method to import from Autodesk Inventor is via Okino’s DWF-3D conversion system. You would obtain a DWF file exported from Autodesk Inventor and import that native file into Okino software. This conversion pipeline also fully supports texture mapping and decals.

This import converter allows data to be directly imported from Autodesk Inventor into any Okino compliant program, such as NuGraf, PolyTrans, the 3ds Max native plug-ins, or the Maya native plug-in module.

** Download the newest "Inventor Viewer" From www.autodesk.com

If you do not have a copy of Autodesk Inventor installed on your computer then you will need to install the Inventor "Apprentice Server" COM component module. This module allows Okino's Inventor importer to import data from .iam assembly files and/or .ipt part files without need for a full resident copy of Autodesk Inventor.

This "Apprentice Server" is distributed by Autodesk in an installer called "Inventor View". Do not install this if you have a full copy of Autodesk Inventor installed on your computer.

If you wish to download the "Inventor View" installer from the Autodesk WEB site then visit "http://www.autodesk.com/inventorview"

** Important - Update Your Copy of Autodesk Inventor **

You should download and install the most recent service pack for Autodesk Inventor from the Autodesk WEB site. See the previous section which describes how to navigate to the support section of the Autodesk Inventor WEB site.

Texture Mapping Note:

If you wish to properly import texture mapped objects from Inventor then the texture maps should be accessible to this importer. Autodesk Inventor uses "real world scaling" for its textures, and hence the Okino importer must open up the texture map images (during the import phase) to determine each of their "dots per inch" scaling factors. If the texture maps cannot be found then the texture images will be assumed to be 96dpi

See Also:

Features of the Autodesk Inventor Import Conversion System

Visual Snapshot Index of Each Import Converter Panel

Important Runtime Information, How-To’s, and Execution Notes

Autodesk Inventor "Automation Server" - An Overview

The File Import Process Using Okino’s PolyTrans or NuGraf

Inventorâ is a registered trademark of Autodesk Corporation. 3ds Maxâ and Mayaâ are registered trademarks of Autodesk. All other brand names, product names or trademarks belong to their respective holders.


Visual Snapshot Index of Each Import Converter Panel

Click below for help on any Autodesk Inventor import converter panel:

Intro Panel | Data Source Selection | Beginner/Expert Mode
Apprentice-Server vs. Automation Modes | Beginner Precision | Expert Precision
Expert Precision # 2 | Material Import | Material Tweaks

Errors, Statistics & Scaling


Features of the Import Conversion System

Features of the Autodesk Inventor Import Conversion System

· Import from a live running copy of Autodesk Inventor, or from native Autodesk Inventor .iam and .ipt files on disk (no copy of Autodesk Inventor required for this latter feature).

· Imports and retains: assembly hierarchy information and assembly names, as well as BREP structure of the source model (bodies and faces). Can query accurate vertex normals, uv texture coordinates and UV tangent vectors from Autodesk Inventor directly.

· The quality of the model (the number of polygons) can be controlled when importing from Autodesk Inventor or from disk-based files.

· Import of diffuse, bump and reflection texture maps. Also support for Inventor’s "real world scaling" of texture maps for which the texture repeat (scaling) on an object is dependent upon the "dpi" (dots per inch) value written into each texture image.

· Choose from different LODs ("level of detail" representations) via the options wizard panel.

· Okino's "CAD Scene and Hierarchy Optimization System" has been integrated right into the Autodesk Inventor importer. This is most important when importing large CAD models into 3ds Max, Maya or Lightwave. These animation packages tend to have performance problems then the source CAD model is large, and/or has a large number of individual parts (which is often the case with the BREP model topology of data provided by Autodesk Inventor).

· The native PolyTrans plug-in systems for 3ds Max (PolyTrans-for-3dsMax) and Maya (PolyTrans-for-Maya) have been refined since 1996 specifically for importing large CAD assembly models from Autodesk Inventor. This has come about partly from our good software users, and also from the main Okino CAD programmers who have been specializing in CAD to non-CAD conversion software since 1988.

· Complete control over material parameter modification on an automatic basis. Many CAD systems like Autodesk Inventor have basic material parameters (like color, ambient + diffuse shading coefficients, opacity, etc) but when they are transferred over to a rendering and animation system they often look "too bright" or "highly ambient". This can be expected and is quite normal. The material tweak parameters easily allow such saturated shading values to be automatically compensated.

See Also:

Visual Snapshot Index of Each Import Converter Panel

Important Runtime Information, How-To’s, and Execution Notes

Autodesk Inventor "Automation Server" - An Overview

The File Import Process Using Okino’s PolyTrans or NuGraf


Runtime Suggestions

This short section explains the most fundamental and important suggestions that we pass on to users of the Inventor CAD importer. Taking into account these suggestions will make your usage of the software highly efficient. This section is accessible by pressing the "Suggestions…" hyperlink found on some of the importer wizard panels.

Topology Units: "Bodies" vs "Faces" Suggestions

· For the most memory efficient and fastest imports, always use "Bodies". Each CAD "part" will be imported as one body object, and possibly one additional "quilt" object. This mode will also allow for crack-free mesh creation, whereas the "Faces" mode will not. "Body" mode is not available when uv texture coordinates are requested during import (for texture mapping support) because they can only be queried on a per-face basis.

· Sometimes materials will be assigned to the "face level" in the CAD model and not the "body" level. In such cases, enable the "Faces" radio button and always make sure the "Optimize Hierarchy" option is enabled. "Faces" import mode can be memory inefficient and slow because each CAD "part" will be imported as many individual objects, each object corresponding to one NURBS surface from the original CAD part. Also, crack-free mesh creation cannot be provided since each NURBS surface is imported independently of each other.

"Optimize Hierarchy" Suggestions

· This is absolutely the most important option to keep enabled in most cases. It can make all the difference between importing a CAD model quickly, with little memory usage and the fewest objects verse importing it slowly, with all memory being used up, and with an excessive number of objects. This is particularly true if the Topology radio buttons are set to "Faces". This command will collapse all children objects inside a grouping folder to a single object, and remove extraneous hierarchy folders. It can have profound results, in particular, for CAD models imported into 3ds Max, Maya and Lightwave. This option is not enabled during NURBS surface import since it would otherwise convert all the NURBS to polygons during the collapse process.

Scaling of the Model Suggestions

· Model scaling is an important, yet often overlooked aspect of the CAD import process by our users.

· In a nutshell, you should make sure your imported model generally ranges from 1x1x1 to 1000x1000x1000 units in size. Often we see customers importing a model which is only 0.001 units across - most downstream programs do not have the accuracy to display, render or manipulate such small models. Ditto on the model being too large (e.g. 1 million units wide).

· After your first file import use the destination program to determine the overall width, height and depth of the model, in general scaling terms. This can often be done by moving the cursor across the model and watching the current "XYZ Location" status bar message. If the model is too large, re-import it and change the "Additional Scaling To Apply" type-in box to a number such as 0.1, 0.01 or 0.001 (10x, 100x and 1000x times smaller). If the model is too small, re-import it and change the "Additional Scaling To Apply" type-in box to a number such as 10, 100 or 1000 (10x, 100x and 1000x times larger).

General Suggestions

· Always choose the "Expert Mode" so that you can control all the options discussed above.

See also:

Main Index Page of This Online Help System


Important Runtime Information, How-To’s, and Execution Notes

· How do I fix imported models with "Cracks" between adjacent polygon faces?

If you are finding that holes or cracks appear between adjacent faces of the imported Autodesk Inventor data, then use "Expert Mode" during an import process and set the "Topology Units" option to "Bodies" on the Expert Precision Options # 2 wizard panel. By selecting "Bodies" Autodesk Inventor is able to use equal surface subdivision on both sides of adjacent faces, thus eliminating the cracks.

· My model appears very small when imported into the destination program. Why?

If you created your Autodesk Inventor data in "millimeters" then the model will appear about 1000 times too small when imported into the destination program. The solution is to rescale the imported data to the size you desire using the drop-down scaling combo box shown on the Errors, Statistics & Scaling panel. You can also use this panel to match the source CAD units from Autodesk Inventor to the destination units of your modeling program; for example, 3ds Max uses "inches" by default, Lightwave uses "centimeters" and Maya uses "meters".

· What do I do if "ole_error" or "COleDispatchException" errors are displayed during imports?

To fix these problems, exit Autodesk Inventor and exit the destination program (NuGraf, PolyTrans, Maya or 3ds Max) then try again. You might also want to ensure that Autodesk Inventor is not running as a process in the Windows "Task Manager", "Processes" tab. The errors are happening inside the COM portion of Microsoft Windows because of various blockages in the COM import process. They should never occur if you are running a recent updated release of Autodesk Inventor.

· The import process will just not work. What do I do?

If you are using the "Automation" import option then you must make sure that you have a newer Autodesk Inventor installed on the same computer that this import converter is running on. If you do not have Autodesk Inventor installed then you need to ensure that you have installed the most recent release of "Inventor View" from the Autodesk WEB site (refer to the index page of this help for further information about how to download this installer).

Otherwise, the 100% equally good and equivalent method to import from Autodesk Inventor is via Okino’s DWF-3D conversion system.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Autodesk Inventor "Automation Server" - An Overview


Autodesk Inventor 'COM Automation Server'- An Overview

Autodesk Inventor's "Automation Interface", An Overview

When importing part or assembly data from a live running copy of Autodesk Inventor, the data is transferred from Autodesk Inventor to the Okino side of the pipeline using the Autodesk Inventor "Automation Server Interface". This is an exposed set of functions which Autodesk Inventor "publishes" to the outside world. Okino's Autodesk Inventor importer queries all the part, assembly and material data from the running copy of Autodesk Inventor using this COM interface.

Such a pipeline is exemplified in this diagram:

In this diagram, an Okino compliant software package (such as NuGraf, PolyTrans, 3ds Max or Maya), on the left side, has asked Microsoft Windows to open up the application which "understands" Autodesk Inventor data files. Windows then executes Autodesk Inventor, the application on the right side above, and loads in the specified Autodesk Inventor data file. Using Microsoft "COM" technology, the Okino application on the left side (the "client") obtains direct access to the internal routines and data of Autodesk Inventor on the right side (the data "server"), as if the two programs were running as one. Object mesh data, hierarchy and materials are then directly transferred to the Okino application for subsequent rendering or further data translation. Once the conversion has taken place the connection is closed and Autodesk Inventor is allowed to exit.

Autodesk has also created a smaller stand-alone "Apprentice Server" COM component (installed via the "Inventor View" installer from the Autodesk WEB site). This allows the Okino importer to read in Inventor .iam assembly files and .ipt part files directly from disk without requiring a local resident copy of Inventor to be installed on your machine.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes


The File Import Process Using Okino's PolyTrans Or NuGraf

Once PolyTrans/NuGraf, the Autodesk Inventor plug-in and Autodesk Inventor have been installed on your machine, a typical import process proceeds as follows (the process is similar when importing directly into 3ds Max or Maya directly):

· From the NuGraf File/Import menu, or the PolyTrans Translate!/Import menu, select "Autodesk Inventor File...".

· Autodesk Inventor executes, or the "Apprentice Server" module loads up in the background.

· The Autodesk Inventor import wizard appears inside the NuGraf or PolyTrans software, showing the Intro Panel. The "Next" button is pressed.

· The Data Source Selection panel appears next. This allows you to choose between reading in the data from a Autodesk Inventor file located on your hard disk, or importing data from the currently open Autodesk Inventor document.

· If you select the "Open document file" radio button and press "Browse" then the Microsoft Windows file selector dialog box will appear. One or more Autodesk Inventor part (.ipt) or assembly (.iam) files should be chosen. Assembly files are preferred since they contain more info. The files are loaded into the running copy of Autodesk Inventor once you press the "Next" button.

· The Beginner/Expert Mode panel appears next. This allows you to choose between further panels which are suitable for beginners, or for experts who want ultimate control over the import conversion process.

· Once the source data file has been specified, you will be presented with options on how the data is to be opened. This can be done by "Apprentice Server" or "Automation". The "Apprentice Server" will allow .ipt and .iam files to be opened without a local copy of Autodesk Inventor on your machine. The automation method opens the file in a running copy of Autodesk Inventor and transfers the data using a "COM Server" interface for greater data connectivity.

· If the beginner mode is selected, then the next panel will show the Beginner Precision options. This panel determines what type of geometry attributes are imported (vertices, normals, tangents or auto-computed normals) as well as how many polygons will be used to approximate the parametric solid surfaces of the objects inside Autodesk Inventor (the surface tolerance deviation). Clicking the "Next" button will advance to the last panel of this introduction (the Errors & Stats panel).

· If the expert mode is selected, then the next panel will show the first of two Expert Precision options. This panel determines if polygons, polygons plus computed normals, or polygons + normals + uv texture coordinates + tangent vectors will be imported from Autodesk Inventor. Each increasing level will take longer to import the data. The "Optimize Hierarchy" checkbox will allow you to enable an optimizer which can greatly reduce the number of objects and hierarchy nodes in the imported scene (especially if you use the import "By Face" method).

· The next expert level panel will show the second of two Expert Precision # 2 options. This panel will allow you to further refine which polygon attributes are imported, as well as determine which the objects should be "imported by body" (as one chunk) or "imported by face" (multiple chunks per object); each has its benefits and disadvantages.

· The second last expert level panel will show the Material Import options panel. In the fashion of many Okino import and export converters, this is a key options panel which allows you to modify the imported material properties from Autodesk Inventor so that they will render properly in the destination rendering program. Autodesk Inventor displays models in OpenGL and as such many models are overly saturated in ambient or diffuse color; this saturation of color does not look good in a photo-realistic rendering program. By pressing the "New" or "Details" button, the Material Tweaks sub-dialog box will appear; this dialog box provides a wealth of methods to have the imported material characteristics automatically modified to your liking. Multiple "tweak methods" can be user defined and saved between invocations of this import converter.

· The last panel is the Measurement Units & Statistics panel. This presents some options to control how import converter errors are handled, and whether statistics should be displayed after the import process is completed. It also provides two drop-down combo boxes which allow the imported data to be scaled up in size or scaled down in size, as well as automatically scaled to match the source and destination scaling units.

Once the import wizard goes away, the solid model data in Autodesk Inventor is tesselated into triangular polygons and transferred into Okino's software. The process completes once the entire model has been imported.

See also:

Visual Snapshot Index of Each Import Converter Panel

Autodesk Inventor "Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Intro Panel Options

This is the first panel which appears once the Autodesk Inventor import converter has been loaded.

It will report whether a local resident copy of Autodesk Inventor was found on your computer, and/or if the "Apprentice Server" COM component was found. At least one of these is needed in order to import Autodesk Inventor files.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Autodesk Inventor "Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Data Source Selection Options

This second panel determines whether the import converter will obtain the data from the currently open Autodesk Inventor document, or if a Autodesk Inventor assembly/part file should be opened first in Autodesk Inventor. If you wish to select an Autodesk Inventor part (.ipt) or assembly file (.iam) on disk, then press the "Browse" button and select one or more part or assembly files.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Autodesk Inventor "Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Beginner/Expert Mode Options

This third panel determines whether subsequent panels will show simpler beginner options, or a variety of more complex options for expert users. Click on the telephone image for beginner mode, or the video camera for expert mode. We recommend the expert mode.

If you want to reset all of the import converter options to the default start-up values, then check-mark the "Reset import parameters before continuing" check box before pressing the "Next" button.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Autodesk Inventor "Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Display List vs. Automation Import Options

"Apprentice Server" vs. "Automation" Import Options

The Autodesk Inventor importer can import data using two different mechanisms:

"Apprentice Server Mode"

When the radio button is set to "Using the Apprentice Server" the importer will read in the raw polygon data and assembly hierarchy info contained in each .iam assembly file or .ipt part file located on disk. There is no need to have a copy of Autodesk Inventor on your machine if you use this mode. This is the simplest and most direct route to opening and importing Autodesk Inventor files.

"Automation Mode"

When the radio button is set to "Automation" the importer will start up a hidden copy of Autodesk Inventor in the background and have the selected files(s) loaded into it. Then the Autodesk Inventor importer will use the COM interface to query and import the assembly and part information from the running copy of Autodesk Inventor into the local PolyTrans software.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Autodesk Inventor "Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Beginner Precision Options

For beginners, this is one of the most important import converter panels. It determines "how much" data, how accurately the solid object data from Autodesk Inventor is converted to polygons, and how quickly the import process proceeds.

"Data Completeness" Slider

This slider determines which type of data is actually imported from Autodesk Inventor. Setting the slider all the way to the left will import the least attributes associated with the model, while setting the slider all the way to the right will import the most attributes possible. The increments on this slider are related to the options on the Expert Precision panel as follows:

Minimum - Import polygon data only. The imported data will appear faceted due to the lack of vertex normals. The data will also be "imported by body" which means that each solid entity in Autodesk Inventor (a body) will be imported as its own single object (rather than various sub-objects).

Some - Import polygons and vertex normals (smoothing info). This is useful is you want the imported objects to appear smooth, but you do not want to import uv texture coordinates for texture mapping or UV tangent vectors for bump mapping. Data is "imported by body" (see above).

Most - Import polygons, vertex normals, uv coordinates and texture maps. This is useful is you want the imported objects to appear smooth, and to have default texture coordinates + texture mapping data (such as the diffuse, bump and reflection maps). The data will be "imported by face" which means that each solid will be imported as multiple sub-pieces, arranged in a hierarchical manner.

All - Import polygons, vertex normals, uv coordinates, tangent vectors and texture maps. Same as above except that tangent vectors will be useful for adding bump mapping to objects via texture maps. Data is "imported by face" (see above).

"Surface Precision" Slider

Data inside Autodesk Inventor is represented as "solids". When importing these solids into Okino software they must be approximated by a mesh of connected polygons (triangles). This slider determines how accurately the original solid surfaces are approximated by polygons. If the slider is set all the way to the left, then few polygons will be used and the approximation will be poor; however, the import process will proceed rather quickly. If the slider is set all the way to the right then many polygons will be used and the approximation should be quite accurate; however, the import process speed may be slow due to the larger number of polygons that must be imported.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Autodesk Inventor "Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Expert Precision Options

This is the first expert mode options panel which controls how accurately the solid object data from Autodesk Inventor is converted to polygons, the control over texture mapping data, which LOD representation to load, and the optional import of meta data (properties).

"Surface Deviation" Slider

Data inside Autodesk Inventor is represented as "solids". When importing these solids into Okino software they must be approximated by a mesh of connected polygons (triangles). This slider determines how accurately the original solid surfaces are approximated by polygons. If the slider is set all the way to the right, then few polygons will be used and the approximation will be poor; however, the import process will proceed rather quickly. If the slider is set all the way to the left then many polygons will be used and the approximation should be quite accurate; however, the import process speed may be slow due to the larger number of polygons that must be imported. The numeric value shown to the right of the slider is the maximum allowable deviation between the ideal solids surface and that of the approximated polygon surface; as this number gets smaller a larger number of polygons must be created in order to better approximate the ideal solids surface.

Use Pre-Calculated Polygons Wherever Possible

This checkbox should be disabled if you wish Inventor to compute brand new meshed polygons based on your slider’s current position.

Overview: Autodesk Inventor has a "cache" of pre-computed mesh models for each of its CAD objects. If you modify the "Surface Deviation" slider then one of these internal, pre-defined meshes will be chosen by Inventor during the import process. However, it you wish to override those caches and have Inventor compute a brand new mesh based on your exact "Surface Deviation" slider value, then disable this checkbox.

Name of LOD ("Level of Detail") to Load

This type-in box is the main method to control which "LOD" (Level of Detail) representation is to be chosen for loading from the top-level assembly file. LODs define different Inventor assembly configurations of suppressed components and/or substituted stand-in part files (for faster redrawing within the Inventor software).

The following shows a screen shot of an Autodesk Inventor assembly with these 3 user-created, additional LOD levels:

LevelofDetail1(OnePartSuppressed)

LevelofDetail1(TwoPartsSuppressed)

SubstituteLevelofDetail1

The LOD list can be found by expanding the "Representations" node in the Inventor Model browser pane, and then the "Level of Detail" node. A new LOD can be made active by left double-clicking on its name, or by right clicking on its name and choosing "Activate".

If you need to determine the list of LOD names in the Inventor file, you can do so by importing the top-level assembly file using Okino’s Inventor importer. After the import process is done, look in the Okino message window where you will find the names of all the LODs which were found in the file, as shown here:

You can then highlight one of the LOD names with the mouse and choose the pop-up menu item "Message Output Window / Copy Selected Text to Window" (by pressing down on the icon shown in the upper right corner of the Message Window) to copy the LOD name to the clipboard.

Once you have chosen a LOD name to load, and copied it to the clipboard, you can re-run the Okino Inventor importer and enter this LOD name into the "Name of LOD" edit box (use control-V to paste the name you had previously copied from the "Message Window").

You can also hand-type the LOD name into the edit box if you wish.

During the next import process, only the chosen LOD will be loaded from the top-level assembly. The LOD name is fed to the Inventor COM server whereby it enables that specific LOD for loading.

Import Materials

Enabling this option will allow the Autodesk Inventor material colors, opacity and texture mapping data to be imported. Normally you would keep this option enabled unless Autodesk Inventor or its SDK are found to be temporarily faulty.

Import Texture Map Data (Diffuse, Bump and Reflection Maps)

Enabling this option will allow diffuse, bump and/or reflection texture maps to be imported.

Note-1: the texture names located on disk must be ANSI with no international characters, otherwise they may not be located by Okino software.

As a technical side note, Inventor performs its texture mapping based on "real world scaling". Hence, if a texture mapped brick is made larger, then the texture map is repeated more times across the surface of the object rather than blindly being stretched larger. To allow the Okino importer to recreate this form of texture mapping, it must have access to the original bitmap image files on disk in order to read and extract their "dpi" values (dots per inch).

Note-2: An equally good and equivalent method to import texture maps from Autodesk Inventor is via Okino’s DWF-3D conversion system. You would obtain a DWF file exported from Autodesk Inventor and import that native file into Okino software. The texture map images would be embedded within the DWF files.

Strip off Filepaths From Bitmap Image References

Enabling this option will strip off the absolute texture file path which prefix each texture map image name. So, if the source reference from Inventor is:

c:\image_collection\brick.jpg

then enabling this option will cause the imported texture filename to become just "brick.jpg" with no file path prefix.

Import Meta Data

Enabling this option will import meta data ("properties") found on Inventor assembly, body and part level nodes. Such data can then be re-exported to Okino converters which support meta data. String, integer, float, currency, booleans (as ‘Yes’ and ‘No’) and date meta data will be imported.

In an assembly file (.iam), meta data is located at the top most level node (the assembly node), the occurrence nodes and the surface body nodes. In a part file (.ipt), meta data is located on the surface body node(s).

Optimize Hierarchy

Enabling this option will collapse hierarchies of hundreds of parts into many fewer parts, making the import of large and complex assemblies possible for programs such as 3ds Max, Maya, Lightwave and others (non-CAD programs which suffer in terms of performance for assemblies with large numbers of objects). The documentation for the "Optimize Hierarchy" option can be viewed by pressing the "Options…" button and then the "Help" button on the optimizer's dialog box.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Autodesk Inventor "Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Expert Precision Options # 2

Expert Precision # 2 Options

This expert mode options panel provides control over specialized aspects of the import process. It is only displayed if the "I Would Also Like to Fine Tune the Advanced Options" checkbox is enabled on the previous Expert Precision Panel # 2 dialog box.

The one option that might be most interesting to users is the "Topology Units" (see below).

Optimize vertices to speed up import processing"

If this check box is enabled then all duplicated (redundant) vertices of the imported data will be deleted before any normals, uv coordinates or UV tangent vectors are queried from Autodesk Inventor. This will greatly speed up the import process because redundant data queries will not have to be made.

‘Normals’ Attribute Processing (Pop-Down List Box)

This pop-down list box determines, absolutely, how vertex normals are to be created for the imported polygon data. These options override the vertex normal import methods selected on the previous Expert Precision Panel # 1:

-Skip- No vertex normals will be imported. The imported polygon data will not appear smooth when rendered.

Generate - A smoothing algorithm in the import converter will be enabled to automatically create vertex normals based on smoothing angle. This will create only an approximation of the real vertex normals from Autodesk Inventor. Since the real vertex normals are not imported from Autodesk Inventor, this option is faster than asking Autodesk Inventor for the accurate vertex normals. If this option is chosen then the "Smoothing Angle" text type-in box becomes enabled; higher values (near 90 degrees) will make your objects appear highly smoothed (no sharp corners) whereas lower values (around 15 to 20 degrees) will make your import objects appear more faceted, although smooth where they should be.

Import Only - The true vertex normals will be queried from Autodesk Inventor one by one. This is much slower but produces more accurate results.

Import & Optimize - The same as "Import Only", but the vertex normals will also be optimized so that any redundant coordinates are deleted.

uv Texture Coordinates (Pop-Down List Box)

This pop-down list box determines, absolutely, how vertex uv texture coordinates are to be imported from Autodesk Inventor. These options override the vertex uv texture coordinate import methods selected on the previous Expert Precision Panel # 1:

-Skip- No vertex uv texture coordinates will be imported. You will not be able to apply 2D bitmap textures to the imported objects without these uv texture coordinates.

Import Only - The true vertex uv texture coordinates will be queried from Autodesk Inventor one by one.

Import & Optimize - The same as "Import Only", but the vertex uv texture coordinates will also be optimized so that any redundant coordinates are deleted. This is the default valie.

NOTE: in order to import texture mapped objects you must keep this combo box set to "Import Only" or "Import & Optimize". Also, when uv texture coordinates are enabled for import then the "Topology Units" radio button option will automatically be forced into the "Topology = Faces" state.

UV Tangent Vectors (Pop-Down List Box)

This pop-down list box determines, absolutely, how vertex UV tangent vectors are to be imported from Autodesk Inventor. These options override the vertex UV tangent vector import methods selected on the previous Expert Precision Panel # 1:

-Skip- No vertex UV tangent vectors will be imported. You will not be able to apply 2D bitmap bump mapping textures to the imported objects without these tangent vectors. This is the default option because UV Tangent vectors are super-rarely ever used or needed in any conversion pipeline.

Import Only - The true vertex UV tangent vectors will be queried from Autodesk Inventor one by one.

Import & Optimize - The same as "Import Only", but the vertex UV tangent vectors will also be optimized so that any redundant coordinates are deleted.

Topology Units: Bodies or Faces

Because Autodesk Inventor is a solid modeling package, internally it represents solids in "BREP" form (boundary representation). An object consists of a "body", which is made up of "shells" and each shell is made up of "faces". These faces are not to be confused with polygon faces of other programs. A "face" is usually defined as a NURBS surface in Inventor.

If the "Bodies" option is chosen on this panel then each major object will be imported as one mesh object and you will not be able to easily assign materials to sub-components of the imported object.

If the "Faces" option is chosen on this panel then each major object will be imported as several sub-mesh objects, stored under one hierarchical parent folder (or "null object" as alternative lingo). Since the object is imported as several sub-objects, you may find it easier to assign materials. However, this method can ultimately result in a scene with a very large number of objects; in such cases you can reduce and optimize the number of objects by enabling the " Optimize Hierarchy" checkbox.

If the "Normals" and/or "U/V Texture Coordinates" drop-down list boxes (found on this panel) are set to "Import Only" or "Import & Optimize" then the "Topology Units" radio buttons will always be forced to the "By Face" import option. This is because the import converter can only query accurate normals and uv texture coordinates from Autodesk Inventor when importing by individual faces.

Flip Model so that 'Y' Axis is 'Up'

By default the data is imported so that the 'Y' up axis in Autodesk Inventor becomes the 'Y' up axis in Okino software. If this checkbox is enabled, then the imported data will be reoriented so that the 'Z' axis in Autodesk Inventor becomes the 'Y' Up axis in Okino software.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Autodesk Inventor "Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Material Import Options

In the fashion of many Okino import and export converters, this is a key options panel which allows you to modify the imported material properties from Autodesk Inventor so that they will render properly in the destination rendering program. Autodesk Inventor displays models using OpenGL and as such many models are overly saturated in ambient or diffuse color; this saturation of color does not look good in a photo-realistic rendering program. By pressing the "New" or "Details" button, the Material Tweaks sub-dialog box will appear; this dialog box provides a wealth of methods to have the imported material characteristics automatically modified to your liking. Multiple "tweak methods" can be user defined and saved between invocations of this import converter. The default action is to not modify any imported material characteristics; however, you will often find that imported Autodesk Inventor models appear "too ambient" or "too diffuse".

Import Method (Pop-Down List Box)

By default, three "material import processing" methods have been provided for you by clicking on the pop-down list box. You are also free to define your own methods by pressing the "New" button on the panel which will call up the Material Tweaks sub-dialog box:

Do Not Import Material Properties - No material properties will be imported at all.

Preserve Numerical Values - All materials will be imported from Autodesk Inventor without any change or tweaking.

Preserve Appearance (Recommended) - The material shading coefficients will be set to the following values, ensuring that the model should look ok when rendered:

· Diffuse shading coefficient = 0.4

· Ambient shading coefficient = 0.3

· Specular shading coefficient = 0.7

· Highlight value = 0.12 (0 = wide highlight, 1.0 = narrow highlight)

· Emission (luminous) shading coefficient = 0

· Opacity (inverse of transparency) = 1.0 (fully opaque)

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Autodesk Inventor "Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Material Tweak Options

This sub-dialog box provides ultimate control over how imported material properties should be modified so that the imported model can be rendered nicely in a photo-realistic rendering program. All too often the imported model appears "too ambient" or "too diffuse", resulting in rendered images that are washed out or with no gradual shading effects visible. By default you should use the "Preserve Appearance" pre-defined import method.

First, to add a new material processing method, press the "New" button on the Material Import panel. This will cause the sub-dialog box to appear in which you can set your custom material import processing options.

As an explanation of the various shading parameters listed on the sub-dialog box:

Diffuse: This controls the amount of color reflected from an object based on the direct light shining on it. A good default value is 0.4.

Ambient: This controls the amount of color reflected from an object based on the ambient light in a scene. A good default value is 0.1 through to 0.3.

Specular: This controls the intensity of the highlight on an object. A good default value is 0.7.

Highlight: This controls the width of the specular highlight on an object (0 = wide, 1.0 = very narrow). A good default value is 0.12.

Emission (luminous): This controls how much color is added to an object, irrespective of any light which shines on it (the higher the value, the more the object will appear to glow). In general you should keep this value at 0.

Opacity: This is the inverse of transparency. 0.0 will make the object fully transparent, while at 1.0 the object will be fully opaque.

For each material property, several actions can be performed on it during the import from Autodesk Inventor. Two sets of actions are provided, that which is performed when the diffuse color values is being imported and those which are performed when all other parameters other than diffuse are being imported.

The actions taken when importing the diffuse color value are described as follows:

- Skip - : The diffuse color value is not imported (no color change is made).

Use Default Coefficient: This action imports the diffuse color with no change made at all, but the diffuse shading coefficient for the color will be set to a "pleasant" value resulting in 3D scenes which render "photo-realistically" (in other words, without harsh or overly bright colors). This coefficient typically ranges from 0.3 through to 0.5. The "coefficient" mentioned here is the same as the "Shading Coefficients" on the "Color" surface attribute editor in Okino’s NuGraf Rendering System software.

Set Coefficient To: This behaves the same as "Use Default Coefficient" except that the diffuse shading coefficient for the diffuse color is set to a user specified value. Let’s assume you set this shading coefficient to 1.0 (the worse case); this would result in a rendered scene which was over saturated in diffuse color. To circumvent this problem (as is done in all 3D rendering packages), we "attenuate" the diffuse color by a specific percentage so that it won’t saturate the final rendered image when the shading is done.

Normalize Color and Coefficient: This is a hybrid approach which tries to automatically "guess" at proper diffuse shading coefficient values using the raw diffuse color imported from Autodesk Inventor. As mentioned, this shading coefficient is needed to create nice looking (nicely shaded) images in a photo-realistic rendering program. If this drop-down box option is chosen, then the diffuse shading coefficient will be derived directly from the relative intensity of the imported diffuse color. For example, if the imported diffuse color is (0.4, 0, 0), which is 40% of full-bright red, then the diffuse shading coefficient will be set to 0.4 and the diffuse color will be modified to be (1, 0, 0). When the new color (1,0,0) and the new shading coefficient (0.4) are multiplied together, it results in the original color imported from Autodesk Inventor (0.4, 0, 0). In general you may wish to use the "Use Default Coefficient" option to get good rendered results.

The actions taken when importing all parameters other than "diffuse" are described as follows (highlight value and opacity):

- Skip - : The material parameter is ignored during import.

Import Unchanged: The material parameter is imported as is, with no change.

Unconditionally Set To: The material parameter is not imported but rather it is set to the numeric value on the dialog box.

Import and Crop by: The material parameter is imported and remains unchanged if it is less than the numeric value on the dialog box. If it is greater, then the imported value will be clamped to be no greater than the numeric value on the dialog box.

Import and Scale by: The material parameter is imported and scaled by the numeric value on the dialog box.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Autodesk Inventor "Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Errors and Statistics

Units Matching, Statistics & Error Reporting

One of the primary uses of this panel is to set up the "units matching". Data from Autodesk Inventor comes across the conversion pipeline in terms of "meters". However, the destination 3D program may not be using meters as its default measurement units. For example, 3ds Max uses "inches" by default, Lightwave uses "cm", Maya uses "meters" and MicroStation uses "mm". The combo boxes on this panel allows the measurement units to be matched, as well as additional scaling to be applied to the imported geometry data.

Data Scale

"Units conversion" is often an important aspect of importing CAD files. People who create 3D models in a modeling package will do so using a specific units system, such as meters or feet. However, when these models are imported into another 3D package that uses a different default units system (such as Lightwave which uses centimeters), a "units conversion" operation needs to occur (the imported model geometry needs to be rescaled).

This import panel determines what will be done when the units defined in the Autodesk Inventor file do not match current internal system units. If the units do not match, the Autodesk Inventor importer will rescale the imported geometry based on the ratio between the Autodesk Inventor units and the internal system units.

Unit of Measurement

You need to set this combo box to the measurement units system in effect for your destination 3D program. For example, set it to centimeters for Lightwave, inches for 3ds Max, centimeters for Maya, etc.

If you are importing into the Okino PolyTrans or NuGraf programs then you can either set the destination units measurement system via this combo box or set the combo box to "Current System" and then set the measurement system inside the main PolyTrans/NuGraf program (Edit/Preferences/Startup Preferences/Other/System Units).

Ignored | No units; never do any geometry scaling
Current System | Scale data to match current internal Okino units
Use Document | Set Okino units to the file’s units. No scaling done
Microinches | 1e-6 inches
Mils | 1e-3 inches
Inches | 2.54 centimeters
Feet | 12 inches
Yards | 36 inches
Miles | 1.6 kilometers
Microns | 1e-6 meters
Millimeters | 1e-3 meters
Centimeters | 1e-2 meters
Decimeters | 1e-1 meters
Meters | 3.28 feet
Kilometers | 0.62 mile
Custom | Custom units are in effect

If the "Custom" option is chosen then the numeric value contained in the "Additional scaling to apply" edit control defines the "units per meter" scale factor for a custom unit system. For example, if you were to enter "0.62" into the type-in box then this would be equivalent to the "Kilometers" units measurement system.

Additional Scaling to Apply (Combo Box)

This drop-down combo box allows imported geometry to be scaled up or down in size by units of 10, 100 or 1000 times. You are free to enter your own scaling factor into the type-in portion of the combo box if you wish (such as "5000"). If you created your model within Autodesk Inventor using "millimeters", for example, then the model will appear about 1000 times too small when imported into the destination program. The solution is to select a scaling option on this wizard panel appropriate for the size of the data as it appears in Autodesk Inventor. For example, if you model in millimeters within Autodesk Inventor then you will want to scale up by 1000 units so that the imported model will not look tiny.

NOTE: If the "Unit of Measurement" combo box is set to "Custom" then the "Additional scaling to apply" edit control defines the "units per meter" scale factor and not an absolute scaling factor.

Runtime Import Options

Tolerate File Integrity Errors

If this option is enabled then the converter will not stop if it receives unexpected data as a result of a data query to Autodesk Inventor; in this case the import converter will just skip over that element and continue importing.

Report Statistics About the Imported File

If this check box is enabled then statistics will be reported after the data has been imported.

Merge Triangles To Quads, Max Angle = #

Autodesk Inventor, and all top-6 MCAD programs since the invention of NURBS in the 1980’s, always output triangular meshes and not quad meshes. This is because quads cannot accurately represent the curvature of NURBS surfaces.

This option is a post-processing step that merges triangles back to quadrilateral polygons (4 sided polygons). The number of vertices remain the same but the overall number of polygons are reduced.

If this option is enabled (check marked) then an algorithm will be invoked which merges multiple polygons into quads. If two adjacent triangles are nearly co-planar then they will be turned into a quadrilateral. The vertices of the adjacent edges must be welded together (shared) for this operation to proceed properly.

The test for co-planar polygons (polygons which are almost on the same plane as each other) is determined by the "Max angle" type-in box. This value is measured in degrees. Values near 0 will require that adjacent polygons be very much co-planar with each other, while higher values will allow polygons that meet at an angle to be considered. For example, if you have a curved object made of triangles then try setting the angle to 4 to 7 degrees. Higher values will allow more polygons to be merged.

NOTE: you can also apply this merging algorithm via the "Polygon Processing" functionality found in the stand-alone Okino software. On that dialog box you would invoke the "Merge Co-Planar Polygons into larger polygons" function. That alternative version also provides some more controls over whether vertex normals, vertex colors and vertex uv’s are to be taken into account (they are all taken into account when invoked via the polygon reduction system).

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Autodesk Inventor "Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


AFX_HIDP_default

No Help Available

No help is available for this message box.

<< If you wish to author help specific to each message box prompt, then remove the AFX_HIDP_xxx values from the [ALIAS] section of your .HPJ file, and author a topic for each AFX_HIDP_xxx value. For example, AFX_HIDP_INVALID_FILENAME is the help topic for the Invalid Filename message box. >>


HID_HELP


HID_HT_NOWHERE

No Help Available

No help is available for this area of the window.


HID_WIZBACK


HID_WIZFINISH


HID_WIZNEXT


HIDC_ANGLE

This value controls the smoothing criterion used when normals are being generated (as opposed to being queried from the server). It is based on the angle between abutting polygons; common smoothed vertex normals will be computed if the angle between their geometric surface normals is less than the angle specified.

Defaults to 45 degrees. Increase this value if the imported object appear to have overly rough surface. Decrease this value if the surface appears to be overly smoothed.


HIDC_BANNER


HIDC_BEGINNER


HIDC_BODIES


HIDC_ERROR_TORERANT


HIDC_EXPERT


HIDC_FACES


HIDC_FLIP_Y_UP

If this option is enabled then the model will be rotated so that its Up axis is aligned with the positive Y-axis instead of the positive Z-axis.


HIDC_NORMALS


HIDC_OPEN_CURRENT


HIDC_OPEN_FILE


HIDC_OPTIMIZE_VERTICES


HIDC_REPORT_STATS

If this checkbox is enabled then the import converter will print out the number of objects, polygons, normals, texture coordinates, tangent vectors and surfaces that were parsed from the SAT file.


HIDC_RESET_DEFAULT


HIDC_TANGENTS

If this checkbox is enabled then the import converter will import proper tangent vectors for each triangle vertex. Tangent vectors are necessary if bump map texture image is to be applied to the object at some time in the future.


HIDC_UV

If this checkbox is enabled then the import converter will import proper texture (u,v) coordinates for each triangle vertex. Texture coordinates are necessary if a bitmap texture image is to be applied to the object at some time in the future


HIDP_INVALID_PATH

Invalid Path

HIDP_INVALID_PATH